#include<jni.h>
#include "Generalcall.h"
#include <stdlib.h>
#include <stdio.h>

JNIEXPORT jstring JNICALL Java_nativ_generalcall_Generalcall_generalcall(JNIEnv *env, jclass clazz, jstring in_befehl)                                                                   
{
    FILE* f;
    int i;
    int c;
    const char* ergaenzung = " > /mnt-system/out.txt 2> /mnt-system/err.txt";
    char *puffer1;
    char *puffer2;
    int anz,anzout,anzerr;

    //Von Java bergebenes String mit dem auszufhrenden Konsolenbefehl in char* wandeln:
    const char *befehl = (*env)->GetStringUTFChars(env, in_befehl, 0);

    system(befehl);


    //Zeichenanzahl in err.txt und out.txt feststellen:
    f = fopen("/mnt-system/out.txt","r");
    c = fgetc(f);
    anzout=0;    
    while(c>=0)
    {
        //puffer[anz]=c;
        c = fgetc(f);
        anzout++;
    }
    fclose(f);    

    f = fopen("/mnt-system/err.txt","r");
    c = fgetc(f);
    anzerr=0;    
    while(c>=0)
    {
        //puffer[anz]=c;
        c = fgetc(f);
        anzerr++;
    }
    fclose(f);    

    //Speicher in passender Gre allokieren, damit die Dateien out.txt und err.txt darin Platz haben.
    //Es wird zuerst err.txt eingelesen und dann out.txt
    //Die Dateien werden durch einen klar erkennbaren Trenner unterteilt, fr den auch noch Speicherplatz
    //reserviert werden mu.
    //Der Trenner heit: !&$%#
    //Falls jemand auf die Idee kme, genau diese Zeichenfolge ausgeben zu lassen in dem Konsolenprogramm,
    //dann wre das groes Pech.
    puffer2 = (char*)malloc((anzout+5+anzerr+1)*sizeof(char));

    //Jetzt werden die Daten in den puffer2 bertragen:    
    f = fopen("/mnt-system/out.txt","r");
    c = fgetc(f);
    anzout=0;    
    while(c>=0)
    {
        puffer2[anzout]=c;
        c = fgetc(f);
        anzout++;
    }
    fclose(f);    


    puffer2[anzout] = '!';
    puffer2[anzout+1] = '&';
    puffer2[anzout+2] = '$';
    puffer2[anzout+3] = '%';
    puffer2[anzout+4] = '#';
    f = fopen("/mnt-system/err.txt","r");
    c = fgetc(f);
    anzerr=0;    
    while(c>=0)
    {
        puffer2[anzout+5+anzerr]=c;
        c = fgetc(f);
        anzerr++;
    }
    fclose(f);    


    puffer2[anzout+5+anzerr]='\0';

    return (*env)->NewStringUTF(env, puffer2);  //Rckgabe an Java der Dateiinhalte von out.txt und err.txt
}
